import DynamoDBDocument, { DeleteCommandInput, DeleteCommandOutput, Item } from '../DocumentClient';
import Query from './Query';
import { ConditionGenerator } from '../expressions/ConditionExpression';
declare type QueryInput<K> = Omit<DeleteCommandInput, 'Key'> & {
    Key: K;
};
declare type QueryOutput<T> = Omit<DeleteCommandOutput, 'Attributes'> & {
    Attributes?: T;
};
export default class DeleteQuery<T extends K, K extends Item> extends Query<T, QueryInput<K>, QueryOutput<T>> {
    private values;
    private conditions;
    constructor(client: DynamoDBDocument, params: QueryInput<K>);
    protected handleInputUpdated(): void;
    protected syncInput(): void;
    condition(fn: ConditionGenerator<T>): this;
}
export {};
