import DynamoDBDocument, { Item, QueryCommandInput, QueryCommandOutput } from '../DocumentClient';
import { ItemProjection, ProjectionFields } from '../expressions/ProjectionExpression';
import ItemsQuery from './ItemsQuery';
import { ConditionExpression } from '../expressions';
import { ConditionGenerator } from '../expressions/ConditionExpression';
declare type QueryInput = QueryCommandInput;
declare type QueryOutput<T, K> = Omit<QueryCommandOutput, 'Items'> & {
    Items?: T[];
    LastEvaluatedKey?: K;
};
export default class QueryQuery<T extends K, K extends Item> extends ItemsQuery<T, K, QueryInput, QueryOutput<T, K>> {
    protected keyConditions: ConditionExpression<T>;
    constructor(client: DynamoDBDocument, params: QueryInput);
    protected handleInputUpdated(): void;
    protected syncInput(): void;
    reverseIndex(flag?: boolean): this;
    project<P extends ProjectionFields<T>>(fields: P): this & QueryQuery<K & ItemProjection<T, P>, K>;
    keyCondition(fn: ConditionGenerator<K>): this;
}
export {};
